digiKam Developer Documentation: Digikam::DRawDecoderSettings Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
Digikam::DRawDecoderSettings Class Reference

## Public Types
enum | DecodingQuality { BILINEAR = 0 , VNG = 1 , PPG = 2 , AHD = 3 , DCB = 4 , DHT = 11 , AAHD = 12 }
| RAW decoding Interpolation methods. More...
enum | InputColorSpace { NOINPUTCS = 0 , EMBEDDED , CUSTOMINPUTCS }
| Input color profile used to decoded image NOINPUTCS: No input color profile. More...
enum | NoiseReduction { NONR = 0 , WAVELETSNR , FBDDNR }
| Noise Reduction method to apply before demosaicing NONR: No noise reduction. More...
enum | OutputColorSpace { RAWCOLOR = 0 , SRGB , ADOBERGB , WIDEGAMMUT , PROPHOTO , CUSTOMOUTPUTCS }
| Output RGB color space used to decoded image RAWCOLOR: No output color profile (Linear RAW). More...
enum | WhiteBalance { NONE = 0 , CAMERA = 1 , AUTO = 2 , CUSTOM = 3 , AERA = 4 }
| White balances alternatives NONE: no white balance used : reverts to standard daylight D65 WB. More...

## Public Member Functions
| DRawDecoderSettings ()=default
| Standard constructor with default settings.
| DRawDecoderSettings (const DRawDecoderSettings &o)
| Equivalent to the copy constructor.
| ~DRawDecoderSettings ()=default
| Standard destructor.
DRawDecoderSettings & | operator= (const DRawDecoderSettings &o)
bool | operator== (const DRawDecoderSettings &o) const
| Compare for equality.
void | optimizeTimeLoading ()
| Method to use a settings to optimize time loading, for example to compute image histogram.

## Public Attributes
bool | autoBrightness = true
| If false, use a fixed white level, ignoring the image histogram.
int | blackPoint = 0
| Black Point value of output image.
double | brightness = 1.0
| Brightness of output image.
int | customWhiteBalance = 6500
| The temperature and the green multiplier of the custom white balance.
double | customWhiteBalanceGreen = 1.0
bool | dcbEnhanceFl = false
| Turn on the DCB interpolation with enhance interpolated colors.
int | dcbIterations = -1
| For DCB interpolation.
QString | deadPixelMap
| Path to text file including dead pixel list.
bool | DontStretchPixels = false
| For cameras with non-square pixels, do not stretch the image to its correct aspect ratio.
bool | enableBlackPoint = false
| Turn on the black point setting to decode RAW image.
bool | enableWhitePoint = false
| Turn on the white point setting to decode RAW image.
bool | expoCorrection = false
| Turn on the Exposure Correction before interpolation.
double | expoCorrectionHighlight = 0.0
| Amount of highlight preservation for exposure correction before interpolation in E.V.
double | expoCorrectionShift = 1.0
| Shift of Exposure Correction before interpolation in linear scale.
bool | fixColorsHighlights = false
| If true, images with overblown channels are processed much more accurate, without 'pink clouds' (and blue highlights under tungsten lamps).
bool | halfSizeColorImage = false
| Half-size color image decoding (twice as fast as "enableRAWQuality").
InputColorSpace | inputColorSpace = NOINPUTCS
| The input color profile used to decoded RAW data.
QString | inputProfile
| Path to custom input ICC profile to define the camera's raw colorspace.
int | medianFilterPasses = 0
| After interpolation, clean up color artifacts by repeatedly applying a 3x3 median filter to the R-G and B-G channels.
int | NRThreshold = 0
| Noise reduction threshold value.
NoiseReduction | NRType = NONR
| Noise reduction method to apply before demosaicing.
OutputColorSpace | outputColorSpace = SRGB
| The output color profile used to decoded RAW data.
QString | outputProfile
| Path to custom output ICC profile to define the color workspace.
DecodingQuality | RAWQuality = BILINEAR
| RAW quality decoding factor value.
bool | RGBInterpolate4Colors = false
| Turn on RAW file decoding using RGB interpolation as four colors.
bool | sixteenBitsImage = false
| Turn on RAW file decoding in 16 bits per color per pixel instead 8 bits.
int | unclipColors = 0
| Unclip Highlight color level: 0 = Clip all highlights to solid white.
WhiteBalance | whiteBalance = CAMERA
| White balance type to use.
QRect | whiteBalanceArea
| Rectangle used to calculate the white balance by averaging the region of image.
int | whitePoint = 0
| White Point value of output image.

## Member Enumeration Documentation

## ◆ DecodingQuality

enum Digikam::DRawDecoderSettings::DecodingQuality

Note
  from original dcraw demosaic

Bilinear: use high-speed but low-quality bilinear interpolation (default - for slow computer). In this method, the red value of a non-red pixel is computed as the average of the adjacent red pixels, and similar for blue and green. VNG: use Variable Number of Gradients interpolation. This method computes gradients near the pixel of interest and uses the lower gradients (representing smoother and more similar parts of the image) to make an estimate. PPG: use Patterned Pixel Grouping interpolation. Pixel Grouping uses assumptions about natural scenery in making estimates. It has fewer color artifacts on natural images than the Variable Number of Gradients method. AHD: use Adaptive Homogeneity-Directed interpolation. This method selects the direction of interpolation so as to maximize a homogeneity metric, thus typically minimizing color artifacts. DCB: DCB interpolation (see www.linuxphoto.org/html/dcb.html for details) DHT: DHT interpolation. AAHD: Enhanced Adaptive AHD interpolation.

## ◆ InputColorSpace

enum Digikam::DRawDecoderSettings::InputColorSpace

EMBEDDED: Use the camera profile embedded in RAW file if exist. CUSTOMINPUTCS: Use a custom input color space profile.

## ◆ NoiseReduction

enum Digikam::DRawDecoderSettings::NoiseReduction

WAVELETSNR: wavelets correction to erase noise while preserving real detail. It's applied after interpolation. FBDDNR: Fake Before Demosaicing Denoising noise reduction. It's applied before interpolation.

## ◆ OutputColorSpace

enum Digikam::DRawDecoderSettings::OutputColorSpace

SRGB: Use standard sRGB color space. ADOBERGB: Use standard Adobe RGB color space. WIDEGAMMUT: Use standard RGB Wide Gamut color space. PROPHOTO: Use standard RGB Pro Photo color space. CUSTOMOUTPUTCS: Use a custom workspace color profile.

## ◆ WhiteBalance

enum Digikam::DRawDecoderSettings::WhiteBalance

CAMERA: Use the camera embedded WB if available. Reverts to NONE if not. AUTO: Averages an auto WB on the entire image. CUSTOM: Let use set it's own temperature and green factor (later converted to RGBG factors). AERA: Let use an area from image to average white balance (see whiteBalanceArea for details).

## Member Data Documentation

## ◆ dcbIterations

int Digikam::DRawDecoderSettings::dcbIterations = -1

Number of DCB median filtering correction passes. -1 : disable (default) 1-10 : DCB correction passes

## ◆ DontStretchPixels

bool Digikam::DRawDecoderSettings::DontStretchPixels = false

In any case, this option guarantees that each output pixel corresponds to one RAW pixel.

## ◆ expoCorrectionHighlight

double Digikam::DRawDecoderSettings::expoCorrectionHighlight = 0.0

Usable range is from 0.0 (linear exposure shift, highlights may blow) to 1.0 (maximum highlights preservation) This settings can only take effect if expoCorrectionShift > 1.0.

## ◆ expoCorrectionShift

double Digikam::DRawDecoderSettings::expoCorrectionShift = 1.0

Usable range is from 0.25 (darken image 1 stop : -2EV) to 8.0 (lighten ~1.5 photographic stops : +3EV).

## ◆ halfSizeColorImage

bool Digikam::DRawDecoderSettings::halfSizeColorImage = false

Turn on this option to reduce time loading to render histogram for example, no to render an image to screen.

## ◆ inputColorSpace

InputColorSpace Digikam::DRawDecoderSettings::inputColorSpace = NOINPUTCS

See OutputColorProfile values for details.

## ◆ NRThreshold

int Digikam::DRawDecoderSettings::NRThreshold = 0

Null value disable NR. Range is between 100 and 1000. For IMPULSENR : set the amount of Luminance impulse denoise.

## ◆ outputColorSpace

OutputColorSpace Digikam::DRawDecoderSettings::outputColorSpace = SRGB

See OutputColorProfile values for details.

## ◆ RAWQuality

DecodingQuality Digikam::DRawDecoderSettings::RAWQuality = BILINEAR

See DecodingQuality values for details.

## ◆ unclipColors

int Digikam::DRawDecoderSettings::unclipColors = 0

1 = Leave highlights unclipped in various shades of pink. 2 = Blend clipped and unclipped values together for a gradual fade to white. 3-9 = Reconstruct highlights. Low numbers favor whites; high numbers favor colors.

## ◆ whiteBalance

WhiteBalance Digikam::DRawDecoderSettings::whiteBalance = CAMERA

See WhiteBalance values for detail